var chancel = false;
var count = 0;
var similarity = 70;
var types = "";
var statuses = [];

function update_statistic() {
    similarity = jQuery("input[name='similarity']:checked").val();
    types = jQuery("input[name='types']:checked").val();
    statuses = [];
    jQuery("#statuses :checked").each(function () {
        statuses.push(jQuery(this).val());
    });
    set_posts_count();
    jQuery('#count').html(count);
}

function set_posts_count() {
    var data = {
        action:'get_posts_count',
        types:types,
        statuses:statuses
    };
    jQuery.ajax({
        type:"POST",
        url:ajaxurl,
        async:false,
        data:data,
        dataType:"json",
        success:function (response) {
            count = response[0];
        },
        error:function (xhr, ajaxOptions, thrownError) {
            jQuery('#log').append(xhr.status + ":" + thrownError);
        }
    });
}

function find_them(startnew) {
    var data = {
        action:'get_duplicate_results',
        types:types,
        similarity:similarity,
        statuses:statuses,
        startnew:startnew
    };
    if (chancel == false) {
        jQuery.ajax({
            type:"POST",
            url:ajaxurl,
            data:data,
            dataType:"json",
            success:function (response) {
                if (response[0] == -1) {
                    jQuery('#log').append(response[1]);
                } else {
                    elements = response[2];
                    jQuery('#log').append(response[1]);
                    done = response[0];
                    found = response[3];
                    jQuery.each(elements, function () {
                        jQuery('#results tbody').append('<tr class="resultrow" id="' + this[0] + '"><td>' + this[2] + '%</td><td><a href="' + this[3] + 'post.php?post=' + this[0] + '&action=edit">' + this[4] + ' (ID: ' + this[0] + ')</a></td><td><a href="' + this[3] + 'post.php?post=' + this[1] + '&action=edit">' + this[5] + ' (ID: ' + this[1] + ')</a></td></tr>');
                    });

                    jQuery('#found').html(found);
                    jQuery('#done').html(done);
                    if (done < count) {
                        find_them(0);
                    } else {
                        jQuery("#chancel").click();
                        if (found > 0) {
                            jQuery("#deletebutton").show();
                        }
                    }
                }
            },
            error:function (xhr, ajaxOptions, thrownError) {
                jQuery('#log').append(xhr.responseText + ":" + thrownError);
            }
        });
    }
}

jQuery(document).ready(function () {
    jQuery('#ajax-loader').ajaxStart(function () {
        jQuery(this).show();
    });

    jQuery('#ajax-loader').ajaxStop(function () {
        jQuery(this).hide();
    });


    update_statistic();

    jQuery("input[name='types']").change(function () {
        update_statistic();
    });

    jQuery("input[name='status']").change(function () {
        update_statistic();
    });

    jQuery("#startbutton").click(function () {
        chancel = false;
        jQuery("#startbutton").hide();
        jQuery("#continuebutton").hide();
        jQuery("#deletebutton").hide();
        jQuery("#chancel").show();
        jQuery(".resultrow").remove();
        update_statistic();
        find_them(1);
    });

    jQuery("#continuebutton").click(function () {
        chancel = false;
        jQuery("#startbutton").hide();
        jQuery("#continuebutton").hide();
        jQuery("#deletebutton").hide();
        jQuery("#chancel").show();
        update_statistic();
        find_them(0);
    });

    jQuery("#deletebutton").click(function () {
        jQuery("#startbutton").hide();
        jQuery("#deletebutton").hide();
        jQuery("#chancel").show();
        chancel = false;
        jQuery(".resultrow").each(function () {
            if (chancel == false) {
                var data = {
                    action:'remove_result',
                    id:jQuery(this).attr('id')
                };
                jQuery.ajax({
                    type:"POST",
                    url:ajaxurl,
                    async:false,
                    data:data,
                    dataType:"json",
                    success:function (response) {
                        if(response[0] == 0) {
                            jQuery('#log').append('Deleting '+response[1]+' failed<br />');
                        } else {
                            jQuery('#log').append('Deleted: '+response[1]+'<br />');
                            jQuery('#' + response[1]).remove();
                        }
                    },
                    error:function (xhr, ajaxOptions, thrownError) {
                        jQuery('#log').append(xhr.status + ":" + thrownError);
                    }
                });
            }
        });
        jQuery("#startbutton").show();
        jQuery("#deletebutton").hide();
        jQuery("#chancel").hide();
    });

    jQuery("#chancel").click(function () {
        chancel = true;
        jQuery("#chancel").hide();
        jQuery("#startbutton").show();
        jQuery("#continuebutton").show();
        if (found > 0) {
            jQuery("#deletebutton").show();
        }
        chancel = true;
    });
});